class EditorCommand
  EDITOR_COMMANDS = { 
    atom: 'atom --wait',
    emacs: 'emacs',
    macvim: 'mvim -f',
    sublime_text: 'subl -n -w',
    vim: 'vim'
  }

  def initialize(editor: nil, command: nil)
    if editor && command
      raise ArgumentError.new('Pass only an editor or a command to Vimput, not both.')
    end

    @editor = editor&.to_sym
    @command = command
  end

  def text
    if command = EDITOR_COMMANDS[@editor]
      command
    elsif @command
      @command
    else
      ENV["VISUAL"] || ENV["EDITOR"] || "vim"
    end
  end
end
